package com.xingxi.master.product.service.impl;

import com.xingxi.common.core.text.Convert;
import com.xingxi.common.enums.EDelFlag;
import com.xingxi.common.utils.DateUtils;
import com.xingxi.common.utils.ShiroUtils;
import com.xingxi.master.product.domain.Prod;
import com.xingxi.master.product.mapper.ProdMapper;
import com.xingxi.master.product.service.IProdService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商品Service业务层处理
 *
 * @author xingxi
 * @date 2025-03-06
 */
@Service
public class ProdServiceImpl implements IProdService {
    @Resource
    private ProdMapper prodMapper;

    /**
     * 查询商品
     *
     * @param id 商品主键
     * @return 商品
     */
    @Override
    public Prod selectProdById(Long id) {
        return prodMapper.selectProdById(id);
    }

    /**
     * 查询商品列表
     *
     * @param prod 商品
     * @return 商品
     */
    @Override
    public List<Prod> selectProdList(Prod prod) {
        prod.setDelFlag(EDelFlag.NO.getVal());
        return prodMapper.selectProdList(prod);
    }

    /**
     * 新增商品
     *
     * @param prod 商品
     * @return 结果
     */
    @Override
    public int insertProd(Prod prod) {
        prod.setDelFlag(EDelFlag.NO.getVal());
        prod.setCreateUser(ShiroUtils.getLoginName());
        prod.setCreateTime(DateUtils.getNowDate());
        return prodMapper.insertProd(prod);
    }

    /**
     * 新增商品
     *
     * @param prodList 商品
     * @return 结果
     */
    @Override
    public int batchInsertProd(List<Prod> prodList) {
        return prodMapper.batchInsertProd(prodList);
    }

    /**
     * 修改商品
     *
     * @param prod 商品
     * @return 结果
     */
    @Override
    public int updateProd(Prod prod) {
        prod.setUpdateUser(ShiroUtils.getLoginName());
        prod.setUpdateTime(DateUtils.getNowDate());
        return prodMapper.updateProd(prod);
    }

    /**
     * 批量删除商品
     *
     * @param ids 需要删除的商品主键
     * @return 结果
     */
    @Override
    public int deleteProdByIds(String ids) {
        return prodMapper.deleteProdByIds(Convert.toStrArray(ids));
    }

    /**
     * 删除商品信息
     *
     * @param id 商品主键
     * @return 结果
     */
    @Override
    public int deleteProdById(Long id) {
        return prodMapper.deleteProdById(id);
    }

    /**
     * 逻辑删除商品
     *
     * @param id 商品主键
     * @return 结果
     */
    @Override
    public int logicDeleteProdById(Long id) {
        return prodMapper.logicDeleteProdById(id);
    }

    /**
     * 逻辑批量删除商品
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    @Override
    public int logicDeleteProdByIds(String ids) {
        return prodMapper.logicDeleteProdByIds(Convert.toStrArray(ids));
    }

    /**
     * 逻辑批量删除商品
     *
     * @param prod 商品
     * @return 结果
     */
    @Override
    public int logicDeleteProdByCondition(Prod prod) {
        return prodMapper.logicDeleteProdByCondition(prod);
    }
}
